import { j as jsxRuntimeExports } from "./jsx-runtime-5a50c612.js";
import { useState } from "react";
import "./SelectionPill.component-b6018daa.js";
import "./Pagination.component-e51641c8.js";
import "./DropDown.component-a587c682.js";
import Icon from "./Icon.js";
import "./TextInput.component-90c3896c.js";
import TextInput from "./TextInput.js";
import "./Widget.component-0498ea87.js";
import "./Uploader.component-051d89e9.js";
import "./TypeAhead.component-af984bb3.js";
import "./Tooltip.component-6cbc4022.js";
import "./Toolbar.component-c4f9504f.js";
import "./Toggle.component-ad6ec6c6.js";
import "./TimeEntry.component-ad86343e.js";
import "./Mask.component-f2e0e458.js";
import "./TextArea.component-53d30f24.js";
import "./Tag.component-811c0aa3.js";
import "./Table.component-d6acf16a.js";
import "./TabBar.component-922755ff.js";
import "./Tab.component-3a3be8cd.js";
import "./Splitter.component-5fa6d66b.js";
import "./Slider.component-33b804b3.js";
import "./Select.component-9c997faa.js";
import "./SegmentedControl.component-d66c5bb4.js";
import "./SecondaryNavigation.component-f82f0403.js";
import "./SearchField.component-06dbf7fe.js";
import "./Radio.component-002fb44f.js";
import "./ProgressStepper.component-a0a5ead6.js";
import "./ProgressIndicator.component-02c23e20.js";
import "./Popover.component-e992934d.js";
import "./Pillbox.component-8ed307ec.js";
import "./Pill.component-9ed1ab12.js";
import "./Picklist.component-4e107b0b.js";
import "./NumericStepper.component-dc827b3b.js";
import "./Notification.component-1a023d74.js";
import "./Modal.component-043bb80f.js";
import "./List.component-940f3c3c.js";
import "./Link.component-2693f973.js";
import "./LearnLink.component-17ee74cf.js";
import "./LabelValue.component-e5e2a27d.js";
import "./InlineMenu.component-9f8bb4dc.js";
import "./FacetedFilter.component-905ac3ed.js";
import "./Dialog.component-6a6bd00e.js";
import "./DetailsPanel.component-912c04f0.js";
import "./PickerRange.component-2575d561.js";
import "./Calendar.component-462a3b9f.js";
import "./DateRange.component-9fc01729.js";
import "./DatePicker.component-fb379443.js";
import "./DateInput.component-c163494b.js";
import "./ContextMenu.component-20b08112.js";
import "./ColorPicker.component-90ff5e5b.js";
import "./Checkbox.component-725133d2.js";
import Button from "./Button.js";
import "./BrowserIncompatibility.component-25fc888f.js";
import "./Breadcrumb.component-5e037f9a.js";
import "./Badge.component-842b16b5.js";
import "./Alert.component-17cbac85.js";
import "./Button.component-61b110ef.js";
import "./Icon.component-8d9e081f.js";
class Helper {
  static populateComponentsInRoutes(routes, components) {
    routes && routes.forEach((route) => {
      const Component = components[route.element];
      route.element = /* @__PURE__ */ jsxRuntimeExports.jsx(Component, {});
      if (route.children) {
        Helper.populateComponentsInRoutes(route.children, components);
      }
    });
  }
  static recrusiveFilter(data, filter, matchCase, searchProps) {
    if (!filter || !data || data.length === 0) {
      return data;
    }
    if (!searchProps || searchProps.length === 0) {
      searchProps = ["label"];
    }
    const dataClone = JSON.parse(JSON.stringify(data));
    const filteredItems = dataClone.filter((obj) => {
      return searchProps && searchProps.reduce((acc, prop) => {
        let isMatch = obj[prop] && (matchCase ? obj[prop].indexOf(filter) > -1 : obj[prop].toLowerCase().indexOf(filter.toLowerCase()) > -1);
        if (obj.children) {
          obj.children = Helper.recrusiveFilter(
            obj.children,
            filter,
            matchCase
          );
          isMatch = isMatch || obj.children.length > 0;
        }
        return acc || isMatch;
      }, false);
    });
    return filteredItems;
  }
  static generateSlices(count, sliceLength, labelFormat) {
    let i = 0, j = 0;
    const slices = [];
    while (i < count) {
      let addUp = sliceLength;
      if (i + sliceLength > count) {
        addUp = count % sliceLength;
      }
      const label = labelFormat === "range" ? i + 1 + " - " + (i + addUp) : "" + (j + 1);
      slices.push(
        /* @__PURE__ */ new Map([
          ["label", label],
          ["name", label.replace(/ /g, "").replace(/-/g, "to")],
          ["sliceIndex", j],
          ["startIndex", i],
          ["endIndex", i + addUp - 1]
        ])
      );
      i += sliceLength;
      j++;
    }
    return slices;
  }
  static aggregate(data, aggregator) {
    let aggregated = /* @__PURE__ */ new Map();
    data.forEach((item) => {
      const key = item[aggregator];
      let aggregatedArray = aggregated.get(key);
      if (!aggregatedArray) {
        aggregatedArray = [];
        aggregated.set(key, aggregatedArray);
      }
      aggregatedArray.push(item);
    });
    return aggregated;
  }
  static generateCategories(data, categories) {
    const groups = /* @__PURE__ */ new Map();
    if (categories && data) {
      categories.forEach((key) => {
        let group = Helper.aggregate(data, key);
        groups.set(key, group);
      });
    }
    return groups;
  }
  static toCamelCase(str, separater, includeFirst) {
    const strParts = str.split(separater || " ");
    return strParts.map(
      (part, i) => i === 0 && includeFirst ? part.charAt(0).toUpperCase() + part.slice(1) : part
    ).join("");
  }
}
const generateRenders = (data, i, onItemSelect) => {
  return data && /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { className: `c-TreeList__list list-unstyled`, children: data.map((obj, index) => /* @__PURE__ */ jsxRuntimeExports.jsx(
    TreeListItem,
    {
      hierarchyLevel: i,
      data: obj,
      onItemSelect
    },
    "TreeListItem" + index
  )) });
};
const TreeListItem = (props) => {
  const { hierarchyLevel, data, onItemSelect } = props;
  const [expanded, setExpanded] = useState(data.expanded);
  let children = null;
  if (data.children) {
    children = generateRenders(data.children, hierarchyLevel + 1, onItemSelect);
  }
  const handleItemClick = () => {
    data.onItemSelect && data.onItemSelect(data);
    if (onItemSelect && !data.skipParentSelector) {
      onItemSelect(data);
    } else {
      console.warn(
        "Parent Selector not called due to the tree item property skipParentSelector!"
      );
    }
    children && setExpanded(!expanded);
  };
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("li", { className: `c-TreeListItem${!expanded ? " expanded" : ""}`, children: [
    /* @__PURE__ */ jsxRuntimeExports.jsxs(
      "span",
      {
        className: "d-inline-block py-2 w-100",
        style: {
          paddingLeft: hierarchyLevel > 0 ? 1.25 + 0.8 * hierarchyLevel + "rem" : 0
        },
        onClick: handleItemClick,
        children: [
          children && /* @__PURE__ */ jsxRuntimeExports.jsx(
            Icon,
            {
              containerClasses: "me-1",
              src: "http://localhost:8080/icon/md/MdKeyboardArrowRight"
            }
          ),
          data.label
        ]
      }
    ),
    children
  ] });
};
const TreeList = (props) => {
  const { data, firstExpanded, noSearch, onItemSelect, title } = props;
  const [filteredItems, setFilteredItems] = useState();
  firstExpanded && data && data[0] && (data[0].expanded = true);
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: "c-TreeList mx-1", children: [
    title && /* @__PURE__ */ jsxRuntimeExports.jsx("strong", { className: "d-block mb-3 mt-2", children: title }),
    !noSearch && /* @__PURE__ */ jsxRuntimeExports.jsx(
      Search,
      {
        data,
        onChange: (e, filteredItems2) => setFilteredItems(filteredItems2)
      }
    ),
    generateRenders(filteredItems || data, 0, onItemSelect)
  ] });
};
const Search = (props) => {
  const { classes, data, placeholder } = props;
  const onChange = "onChange" in props && props.onChange;
  const showPopUp = "showPopUp" in props && props.showPopUp;
  const [filteredItems, setFilteredItems] = useState();
  const [focusClass, setFocusClass] = useState("");
  const onLocalChange = (event) => {
    if (showPopUp) {
      const filteredItems2 = Helper.recrusiveFilter(
        data,
        event.target.value,
        false,
        ["label"]
      );
      setFilteredItems(filteredItems2);
      onChange && onChange(event, filteredItems2);
    } else {
      onChange && onChange(event, null);
    }
  };
  const filteredItemsRenders = filteredItems && filteredItems.map((item) => {
    return /* @__PURE__ */ jsxRuntimeExports.jsx("div", {});
  });
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(
    "div",
    {
      className: `c-Search d-flex w-100 position-relative ${focusClass}${classes ? " " + classes : ""}`,
      children: [
        /* @__PURE__ */ jsxRuntimeExports.jsx(
          TextInput,
          {
            containerClasses: "form-component",
            classes: "c-Search__input p-1 bg-transparent border-0",
            onBlur: () => setFocusClass(""),
            onChange: onLocalChange,
            onFocus: () => setFocusClass("focussed"),
            placeholder: placeholder || "Search",
            type: "text"
          }
        ),
        /* @__PURE__ */ jsxRuntimeExports.jsx(
          Button,
          {
            content: /* @__PURE__ */ jsxRuntimeExports.jsx(Icon, { src: "http://localhost:8080/icon/ai/AiOutlineSearch" }),
            classes: `search-button bg-transparent form-component${focusClass ? " border-bottom-0" : ""}`
          }
        ),
        (!onChange || showPopUp) && /* @__PURE__ */ jsxRuntimeExports.jsx(
          "div",
          {
            className: `c-Search__search-results p-3 position-absolute top-100 start-0 w-100 bg-white border${focusClass ? "" : " h-0 overflow-hidden"}${filteredItemsRenders ? "" : " flex-center"}`,
            onClick: (e) => e.stopPropagation(),
            children: filteredItemsRenders || /* @__PURE__ */ jsxRuntimeExports.jsx("i", { children: "Type to view results here" })
          }
        )
      ]
    }
  );
};
export {
  TreeList as default
};
