import { j as jsxRuntimeExports } from "./jsx-runtime-5a50c612.js";
import { useState } from "react";
import "./AlphabetFilter.component-6891be70.js";
import { H as Helper } from "./helper-6a654f8c.js";
import "./Users.component-471e19e0.js";
import "./Toast.component-2c91db7d.js";
import "./Testimonials.component-d89149a0.js";
import "./Team.component-e54f3f3c.js";
import "./Steps.component-fb614ec4.js";
import "./Stats.component-b52e2043.js";
import "./Snackbar.component-1f40b80f.js";
import "./SignInUp.component-60aa0bd7.js";
import "./Services.component-f17ec135.js";
import "./RichText.component-8c13163e.js";
import "./Reviews.component-2c041df5.js";
import "./Projects.component-4995023a.js";
import "./ProductInfo.component-6f4f0c4e.js";
import "./Pricing.component-c2d76578.js";
import "./Portfolio.component-0c3d2226.js";
import "./Notifications.component-2e7a825b.js";
import "./Newsletter.component-52531f4a.js";
import "./LogoClouds.component-bd581c43.js";
import "./Integrations.component-f49f3bee.js";
import "./InstaPhotos.component-6c3354ca.js";
import "./HowItWorks.component-ba9d9c22.js";
import "./Hero.component-addb168a.js";
import "./HttpCode.component-e0447052.js";
import "./Graph.component-dc7e23cf.js";
import "./GraphTiles.component-dac88886.js";
import "./Gallery.component-ff108003.js";
import "./Form.component-62eb5c58.js";
import "./Footer.component-2a844a60.js";
import "./Features.component-ae834147.js";
import "./Faq.component-33d5b133.js";
import "./Empty.component-c9aaf811.js";
import "./EcommProducts.component-acad1653.js";
import "./EcommOrders.component-1a424b01.js";
import "./Download.component-ddc16bd8.js";
import "./Dashboard.component-9ed086ac.js";
import "./Cookies.component-3b3e68b5.js";
import "./Content.component-5ccc42e8.js";
import "./Contact.component-ce5e0d0d.js";
import "./Careers.component-0d4ad0db.js";
import "./Card.component-49af79be.js";
import "./Cta.component-4b2a1643.js";
import "./Breadcrumbs.component-227f2f6c.js";
import "./Brands.component-b13c37b2.js";
import "./Blog.component-fba44e7a.js";
import "./Benefits.component-b71943a6.js";
import "./Banner.component-dbfc7209.js";
import "./Application.component-4340eb78.js";
import "./AboutUs.component-1dcbbd07.js";
const Icon = (props) => {
  const { classes, containerClasses, height, size, src, width } = props;
  return /* @__PURE__ */ jsxRuntimeExports.jsx(
    "span",
    {
      className: `c-Icon d-inline-block ${containerClasses}`,
      style: {
        width: width || size || "1rem",
        height: height || size || "1rem"
      },
      children: /* @__PURE__ */ jsxRuntimeExports.jsx(
        "img",
        {
          className: `c-Icon__img${classes ? " " + classes : ""}`,
          src,
          alt: "Icon"
        }
      )
    }
  );
};
const TextInput = (props) => {
  const {
    classes,
    containerClasses,
    onBlur,
    onChange,
    onFocus,
    placeholder,
    type
  } = props;
  const [value, setValue] = useState();
  const [focussed, setFocussed] = useState(false);
  const onLocalChange = (event) => {
    setValue(event.target.value);
    onChange && onChange(event);
  };
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(
    "div",
    {
      className: `c-TextInput position-relative w-100${focussed ? " focussed border-bottom-0" : ""}${containerClasses ? " " + containerClasses : ""}`,
      children: [
        /* @__PURE__ */ jsxRuntimeExports.jsx(
          "input",
          {
            type: type || "text",
            className: `c-TextInput__input w-100 h-100${classes ? " " + classes : ""}`,
            onChange: onLocalChange,
            onFocus: (...focusHandlerArgs) => {
              setFocussed(true);
              onFocus && onFocus(...focusHandlerArgs);
            },
            onBlur: (...focusHandlerArgs) => {
              setFocussed(false);
              onBlur && onBlur(...focusHandlerArgs);
            },
            placeholder: focussed ? "" : placeholder
          }
        ),
        /* @__PURE__ */ jsxRuntimeExports.jsx(
          "button",
          {
            className: `c-TextInput__clear-button position-absolute end-0 top-0 d-flex flex-row
          justify-content-center align-items-center h-100 border-0 bg-transparent${value ? " has-value" : ""}${focussed ? " border-bottom-0" : ""}`
          }
        )
      ]
    }
  );
};
const Search = (props) => {
  const { classes, data, placeholder } = props;
  const onChange = "onChange" in props && props.onChange;
  const showPopUp = "showPopUp" in props && props.showPopUp;
  const [filteredItems, setFilteredItems] = useState();
  const [focusClass, setFocusClass] = useState("");
  const onLocalChange = (event) => {
    if (showPopUp) {
      const filteredItems2 = Helper.recrusiveFilter(
        data,
        event.target.value,
        false,
        ["label"]
      );
      setFilteredItems(filteredItems2);
      onChange && onChange(event, filteredItems2);
    } else {
      onChange && onChange(event, null);
    }
  };
  const filteredItemsRenders = filteredItems && filteredItems.map((item) => {
    return /* @__PURE__ */ jsxRuntimeExports.jsx("div", {});
  });
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(
    "div",
    {
      className: `c-Search d-flex w-100 position-relative ${focusClass}${classes ? " " + classes : ""}`,
      children: [
        /* @__PURE__ */ jsxRuntimeExports.jsx(
          TextInput,
          {
            containerClasses: "form-component",
            classes: "c-Search__input p-1 bg-transparent border-0",
            onBlur: () => setFocusClass(""),
            onChange: onLocalChange,
            onFocus: () => setFocusClass("focussed"),
            placeholder: placeholder || "Search",
            type: "text"
          }
        ),
        /* @__PURE__ */ jsxRuntimeExports.jsx(
          Button,
          {
            content: /* @__PURE__ */ jsxRuntimeExports.jsx(Icon, { src: "http://localhost:8080/icon/ai/AiOutlineSearch" }),
            classes: `search-button bg-transparent form-component${focusClass ? " border-bottom-0" : ""}`
          }
        ),
        (!onChange || showPopUp) && /* @__PURE__ */ jsxRuntimeExports.jsx(
          "div",
          {
            className: `c-Search__search-results p-3 position-absolute top-100 start-0 w-100 bg-white border${focusClass ? "" : " h-0 overflow-hidden"}${filteredItemsRenders ? "" : " flex-center"}`,
            onClick: (e) => e.stopPropagation(),
            children: filteredItemsRenders || /* @__PURE__ */ jsxRuntimeExports.jsx("i", { children: "Type to view results here" })
          }
        )
      ]
    }
  );
};
const Button = (props) => {
  const { classes, content } = props;
  return /* @__PURE__ */ jsxRuntimeExports.jsx("button", { className: `c-Button${classes ? " " + classes : ""}`, children: content });
};
export {
  Search as default
};
